--- txtrn.t	2024-09-07 10:59:46.216371000 +0200
+++ txovl.t	2024-09-07 10:58:48.342616000 +0200
@@ -82,8 +82,10 @@
 
 str_equal(s1, s2) return t.memcomp(s1, s2, str_length(s1)+1) = 0;
 
-writes(s) t.write(T3X.SYSOUT, s, str_length(s));
+var	Logfile;
 
+writes(s) t.write(Logfile, s, str_length(s));
+
 nl() do var b::3;
 	writes(t.newline(b));
 end
@@ -106,7 +108,11 @@
 ! Error Reporting
 !
 
+var	Infile;
+
 aw(m, s) do
+	t.close(Infile); ! Only three FDs on CP/M
+	Logfile := t.open("TX0OVL.$$$", T3X.OWRITE);
 	writes("Error: ");
 	if (Modname::0) do
 		writes(Modname);
@@ -120,6 +126,7 @@
 		writes(s);
 	end
 	nl();
+	t.close(Logfile);
 	if (Outname::0) t.remove(Outname);
 	halt 1;
 end
@@ -315,7 +322,6 @@
 
 const	META	 = 256;
 
-var	Infile;
 var	Inbuf::CG.BUFLEN;
 var	Ip, Ep;
 var	Rejected;
@@ -1767,6 +1773,7 @@
 end
 
 info() do
+	Logfile := t.open("TX0OVL.$$$", T3X.OWRITE);
 	! cgstats.print();
 	writes("Text = 0x");
 	writes(ntox(Tp));
@@ -1779,6 +1786,7 @@
 	writes(", Labels = ");
 	writes(ntoa(Lab));
 	nl();
+	t.close(Logfile);
 end
 
 phase(n) do
@@ -1801,6 +1809,7 @@
 	Outname::0 := 0;
 	Verbose := 0;
 	Modname::0 := 0;
+	Logfile := T3X.SYSOUT;
 	k := t.getarg(1, Inname, TOKLEN);
 	if (k < 0) aw("missing file name", 0);
 	t.memcopy(@Inname::k, ".t", 3);
